/*
 * wkf.c - Ѵե륿
 *   Fri, Jan 24 1997 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <utime.h>
#include <signal.h>

#define	WKF_MAIN_FILE
#include "kanji.h"
#include "wkf.h"
#include "version.h"
#undef	WKF_MAIN_FILE

/*
 * ޥ
 */
#define	FILE_LEN	256	/* ե̾Ĺ	*/
#define	LINE_END_LF	"\n"	/* ϲ		*/
#define	LINE_END_CR	"\r"	/* 		*/
#define	LINE_END_CRLF	"\r\n"	/* ܲ	*/

typedef enum {		/* 顼ɡ		*/
  NO_CONVERT_OPTION,	/* Ѵץ󤬤ʤ		*/
  BAD_CONVERT_OPTION,	/* Ѵץ¿Ż		*/
  BAD_CODE_OPTION,	/* ϥɻꥪץ¿Ż	*/
  BAD_LINEEND_OPTION	/* üɻꥪץ¿Ż	*/
} ErrorType;

/*
 * ɽؿ
 */
static void	SavePermission();
static void	SaveTimeStamp();
static char	*TmpName();
static char	*BackupName();
static void	ErrorMesg();
static void	Usage();

/*
 * ؿ̾:	SavePermission
 * ǽ:	ѴΥեΥѡߥåϥեƱˤ
 * :	ϥե̾ѴΥե̾
 * :	ʤ
 */
static void SavePermission(org_name, new_name)
	register char	*org_name, *new_name;
{
  struct stat		sb;

  if (stat(org_name, &sb) != 0) {
    (void)fprintf(stderr, "can't set permission on file %s\n", new_name);
    return;
  }

  if (chmod(new_name, sb.st_mode) != 0) {
    (void)fprintf(stderr, "can't set permission on file %s\n", new_name);
    return;
  }
}

/*
 * ؿ̾:	SaveTimeStamp
 * ǽ:	ѴΥեΥॹפϥեƱˤ
 * :	ϥե̾ѴΥե̾
 * :	ʤ
 */
static void SaveTimeStamp(org_name, new_name)
	register char	*org_name, *new_name;
{
  struct stat		sb;
  struct utimbuf	tb;

  if (stat(org_name, &sb) != 0) {
    (void)fprintf(stderr, "can't set timestamp on file %s\n", new_name);
    return;
  }

  tb.actime  = sb.st_atime;
  tb.modtime = sb.st_mtime;

  if (utime(new_name, &tb) != 0) {
    (void)fprintf(stderr, "can't set timestamp on file %s\n", new_name);
    return;
  }
}

/*
 * ؿ̾:	TmpName
 * ǽ:	ե̾
 * :	ե̾
 * :	ե̾
 */
static char *TmpName(fname)
	register char	*fname;
{
  static char	buf[FILE_LEN];

  memset((char*)buf, (int)0, (size_t)FILE_LEN);
  (void)strcpy(buf, fname);
  (void)strcat(buf, ".tmp~");

  return buf;
}

/*
 * ؿ̾:	BackupName
 * ǽ:	Хååѥե̾
 * :	ե̾
 * :	Хååѥե̾
 */
static char *BackupName(fname)
	register char	*fname;
{
  static char	buf[FILE_LEN];

  memset((char*)buf, (int)0, (size_t)FILE_LEN);
  (void)strcpy(buf, fname);
  (void)strcat(buf, ".bak");

  return buf;
}

/*
 * ؿ̾:	ErrorMesg
 * ǽ:	Ƽ泌顼åɽ
 * :	顼ֹ
 * :	ʤ
 */
static void ErrorMesg(errno)
	ErrorType	errno;
{
  switch (errno) {
    case NO_CONVERT_OPTION:
      (void)fprintf(stderr,
		    "%s: no convert option -- need j or e or s option.\n",
		    Program);
      break;
    case BAD_CONVERT_OPTION:
      (void)fprintf(stderr,
		    "%s: bad option -- j, e, s, c, C selected only one.\n",
		    Program);
      break;
    case BAD_CODE_OPTION:
      (void)fprintf(stderr,
		    "%s: bad option -- J, E, S selected only one.\n",
		    Program);
      break;
    case BAD_LINEEND_OPTION:
      (void)fprintf(stderr, "%s: bad option -- M, D selected only one.\n",
		    Program);
      break;
  }
}

/*
 * ؿ̾:	Usage
 * ǽ:	Ȥɽ
 * :	ʤ
 * :	ʤ
 */
static void Usage(void)
{
  (void)fprintf(stderr,
	"usage: %s [-{j|e|s|c|C}] [-zAT] [-{J|E|S}] [-{M|D}] [<file>...]\n",
	Program);
  exit(1);
}

/*
 * ᥤؿ
 */
int main(argc, argv)
	int	argc;
	char	**argv;
{
  register int		i;
  register char		*tmp, *bck;
  KanjiCode		kcode = C_UNKNOWN;
  KanjiCode		gcode = C_UNKNOWN;
  register Boolean	convert;
  register Boolean	checkcode, showfname, backup, savetstamp, mac, dos;
  register FILE		*fp, *bfp;
  int			kcheck, gcheck;
  register char		c;

  zen2ascii  = FALSE;		/* 2byte -> 1byte ѿѴե饰	*/
  checkcode  = FALSE;		/* ɤΥåե饰		*/
  showfname  = FALSE;		/* Ƚ̻ե̾ɽե饰	*/
  backup     = FALSE;		/* Ѵե¸ե饰	*/
  savetstamp = FALSE;		/* ॹ¸ե饰		*/
  mac	     = FALSE;		/*  Macintosh ǽϥե饰	*/
  dos	     = FALSE;		/*  DOS ǽϥե饰		*/
  lineend    = LINE_END_LF;	/* ǥեȤι LF 		*/
  kcheck = gcheck = 0;

  while ((--argc > 0) && ((*++argv)[0] == '-')) {	/* 	*/
    while ((c = *++argv[0]) != EOL) {
      switch (c) {
	case 'h':			/* Ȥɽ륪ץ	*/
	  (void)fprintf(stderr, "%s\n", Copyright);
	  Usage();
	case 'v':			/* Сɽץ	*/
	  (void)fprintf(stderr, "%s\n", Copyright);
	  exit(0);
	case 'C':			/* ե̾ɽդ		*/
	  showfname = TRUE;
	case 'c':			/* ɥå	*/
	  checkcode = TRUE;
	  break;
	case 'j':			/* JIS ɤѴ		*/
	  kcode = C_NEWJIS;
	  kcheck++;
	  break;
	case 'e':			/* ܸ EUC ɤѴ	*/
	  kcode = C_EUC;
	  kcheck++;
	  break;
	case 's':			/* SJIS ɤѴ		*/
	  kcode = C_SJIS;
	  kcheck++;
	  break;
	case 'z':			/* 2byte ѿ 1byte Ѵ	*/
	  zen2ascii = TRUE;
	  break;
	case 'A':			/* Хååפ	*/
	  backup = TRUE;
	  break;
	case 'T':			/* ॹפ¸	*/
	  savetstamp = TRUE;
	  break;
	case 'M':			/*  Macintosh ǽ	*/
	  lineend = LINE_END_CR;
	  mac	  = TRUE;
	  break;
	case 'D':			/*  DOS ǽ	*/
	  lineend = LINE_END_CRLF;
	  dos	  = TRUE;
	  break;
	case 'J':			/* ϴɤ JIS		*/
	  gcode = C_NEWJIS;
	  gcheck++;
	  break;
	case 'E':			/* ϴɤܸ EUC	*/
	  gcode = C_EUC;
	  gcheck++;
	  break;
	case 'S':			/* ϴɤ Shift-JIS	*/
	  gcode = C_SJIS;
	  gcheck++;
	  break;
	default:			/* ¾Υץϥ顼	*/
	  (void)fprintf(stderr, "%s: illegal option -- %c\n", Program, c);
	  argc = -1;
	  break;
      }
    }
  }

  /* ץΥå(c, C  J, E, S Ʊ¸)	*/
  if (checkcode && gcode != C_UNKNOWN) {
    gcode = C_UNKNOWN;	/* J, E, S ץ̵ˤ	*/
  }

  /* ץΥå(j, e, s, c, C Ʊ¸)	*/
  if ((kcheck > 1) || (kcheck == 1 && checkcode)) {
    ErrorMesg(BAD_CONVERT_OPTION);
    Usage();
  }

  /* ץΥå(J, E, S Ʊ¸)	*/
  if (gcheck > 1) {
    ErrorMesg(BAD_CODE_OPTION);
    Usage();
  }

  /* ץΥå(M, D Ʊ¸)	*/
 if (mac && dos) {
    ErrorMesg(BAD_LINEEND_OPTION);
    Usage();
  }

  /* ץΥå(j, e, s ޤޤƤ뤫)	*/
  if (zen2ascii || backup || savetstamp || mac || dos ||
      (gcheck > 1) || (gcode != C_UNKNOWN)) {
    if (!checkcode && (kcheck == 0)) {
      ErrorMesg(NO_CONVERT_OPTION);
      Usage();
    }
  }

  if (argc > 0) {			/* եν	*/
    for (i = 0; i < argc; i++) {
      signal(SIGINT,  SIG_IGN);
      fp = fopen(argv[i], "r");
      if (fp == NULL) {
	(void)fprintf(stderr, "can't open %s\n", argv[i]);
	continue;
      }
      setvbuf(fp, (char*)NULL, _IOFBF, 0);
      if (showfname && !kcheck) {
	(void)fprintf(stdout, "%-16s\t", argv[i]);
	(void)fflush(stdout);
      }
      if (backup) {
	tmp = TmpName(argv[i]);		/* ѥե̾	*/
	bck = BackupName(argv[i]);	/* Хååѥե̾	*/
	bfp = fopen(tmp, "w");
	if (bfp == NULL) {
	  (void)fprintf(stderr, "can't open backup file for %s\n", argv[i]);
	  continue;
	}
	setvbuf(bfp, (char*)NULL, _IOFBF, 0);
	convert = KanjiCodeConvTo(kcode, gcode, fp, bfp);
	(void)fclose(bfp);
	(void)fflush(fp);
	(void)fclose(fp);
	if (convert) {
	  /* ̾ѹΥ顼å򤷤褦	*/
	  rename(argv[i], bck);
	  rename(tmp, argv[i]);
	  if (savetstamp) {	/* ॹפ¸	*/
	    SaveTimeStamp(bck, argv[i]);
	  }
	  SavePermission(bck, argv[i]);	/* ѡߥå¸	*/
	}
	else {
	  unlink(tmp);	/* ѥե	*/
	}
      }
      else {
	setvbuf(stdout, (char*)NULL, _IOFBF, 0);
	(void)KanjiCodeConvTo(kcode, gcode, fp, stdout);
	(void)fclose(fp);
	(void)fflush(stdout);
      }
      signal(SIGINT,  SIG_DFL);
    }
  }
  else if (argc == 0) {			/* ɸϤν	*/
    if (showfname && !kcheck) {
      (void)fprintf(stdout, "stdin\t");
      (void)fflush(stdout);
    }
    setvbuf(stdin, (char*)NULL, _IOFBF, 0);
    setvbuf(stdout, (char*)NULL, _IOFBF, 0);
    (void)KanjiCodeConvTo(kcode, gcode, stdin, stdout);
    (void)fflush(stdout);
  }
  else {			/* Ȥɽ	*/
    Usage();
  }

  return 0;
}
